#  Copyright 2008 Peter Mora                                                                                                                             
#
#  This file is part of Vakarcs.
#
#  Vakarcs is free software: you can redistribute it and/or modify
#  it under the terms of the GNU General Public License as published by
#  the Free Software Foundation, either version 3 of the License, or
#  (at your option) any later version.
#
#  Vakarcs is distributed in the hope that it will be useful,
#  but WITHOUT ANY WARRANTY; without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#  GNU General Public License for more details.
#
#  You should have received a copy of the GNU General Public License
#  along with Vakarcs.  If not, see <http://www.gnu.org/licenses/>.
# 

draw_map =[ "XXXXXXXXXXXXXXXXXXXX",\
            "XXXXXXXXXXXXXXXXXXXX",\
            "XX................XX",\
            "XX................XX",\
            "XX......XX...XX...XX",\
            "XX......XX...XX...XX",\
            "XX...XXXXXXXXXXXX.XX",\
            "XX................XX",\
            "XX................XX",\
            "XXXXXXX...........XX",\
            "XX...........XXXXXXX",\
            "XX................XX",\
            "XX................XX",\
            "XX.XXXXXXXXXXXX...XX",\
            "XX...XX...XX......XX",\
            "XX...XX...XX......XX",\
            "XX................XX",\
            "XX................XX",\
            "XXXXXXXXXXXXXXXXXXXX",\
            "XXXXXXXXXXXXXXXXXXXX"]
def convert_map(c):
    if c == ".":
        return MAP_EMPTY
    elif c == "X":
        return MAP_WALL

self.map.map = [[convert_map(draw_map[y][x]) for y in range(len(draw_map[0]))] for x in range(len(draw_map))]
self.number_of_steps = 4
self.number_of_players = 2
self.shop = [[10, "wizzard", [Ability("move","dir",{}),Ability("distsee","static",[8]),Ability("cloak","static",[])],{}],\
        [10,"warrior",[Ability("move","dir",[]),Ability("shootdir","dir",[]),Ability("shootpos","pos",[6])],{}],\
        [3,"crazy",[],{"crazymove":10,"truesight":1}],\
        [10,"builder",[Ability("move","dir",{}),Ability("build","dir",[]),Ability("destroy","dir",{})],{}]]
self.map.shop = self.shop
self.map.objects = [Object(0,"master",[11,4],self,[Ability("move","dir",[])],{"life":1,"seedist":10}), \
        Object(0,"warrior",[10,3],self,shop=self.shop), \
        Object(0,"warrior",[12,3],self,shop=self.shop), \
        Object(0,"builder",[12,2],self,shop=self.shop), \
        Object(0,"crazy",[10,4],self,shop=self.shop), \
        Object(0,"wizzard",[11,2],self,shop=self.shop),\
        Object(1,"wizzard",[8,17],self,shop=self.shop),\
        Object(1,"warrior",[9,16],self,shop=self.shop), \
        Object(1,"warrior",[7,16],self,shop=self.shop), \
        Object(1,"builder",[8,17],self,shop=self.shop), \
        Object(1,"crazy",[8,16],self,shop=self.shop), \
        Object(1,"master",[8,15],self,[Ability("move","dir",[])],{"life":1,"seedist":10})]

self.money_per_round = 1
self.start_money = 5
self.shopable = "master"

def check_end(self):
    r = []
    for p in self.players:
        if len([1 for ob in self.map.objects if ob.owner == p.id and ob.type == "master"]) > 0:
            r += [p.id]
    if sorted(r) == range(self.number_of_players):
        return []
    if r == []:
        return range(self.number_of_players)
    return r

self.check_end = check_end
