#!/usr/bin/env python
# -*- coding: utf-8 -*-

#  Copyright 2008 Peter Mora                                                                                                                             
#
#  This file is part of Vakarcs.
#
#  Vakarcs is free software: you can redistribute it and/or modify
#  it under the terms of the GNU General Public License as published by
#  the Free Software Foundation, either version 3 of the License, or
#  (at your option) any later version.
#
#  Vakarcs is distributed in the hope that it will be useful,
#  but WITHOUT ANY WARRANTY; without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#  GNU General Public License for more details.
#
#  You should have received a copy of the GNU General Public License
#  along with Vakarcs.  If not, see <http://www.gnu.org/licenses/>.
#   

import sys, os;

import pygame
from ui import *
from pygame.locals import *

if not pygame.font: print 'Warning, fonts disabled'
if not pygame.mixer: print 'Warning, sound disabled'



menu_list = [u"Kapcsolódás szerverhez",u"Szerver indítása",u"Játékszabály",u"Kilépés"]


def menu(active):
    if active == 0:
        server_name = input_text("Szerver: ", "localhost")
        name = input_text("Neved: ", "")
        myui = Ui(name,server_name)
        myui.run()
    elif active==1:  
        name = input_text("Neved: ", "")
        maps = filter(lambda x: x[:4]=="map_" and x[-3:]==".py",filter(os.path.isfile,os.listdir(".")))
        if maps==[]:
            raise Exception("No maps") 
        map = maps[menu_choose(u"Válassz pályát!",maps)][:-3]
        myui = Ui(name,map=map)
        myui.run()
    elif active==3:
        sys.exit(0)


if len(sys.argv) == 4 and sys.argv[1] in ["server","client"]:
    if sys.argv[1] == "client":
        myui = Ui(sys.argv[2],sys.argv[3])
        myui.run()
    else:
        myui = Ui(sys.argv[2],map=sys.argv[3])
        myui.run()
else: 
    menu(menu_choose("Vakarcs",menu_list))
